GstPhotography

## GstPhotography GstPhotography |

## Functions

void | (*GstPhotoCapturePrepared) ()
gboolean | gst_photography_get_ev_compensation ()
gboolean | gst_photography_get_iso_speed ()
gboolean | gst_photography_get_aperture ()
gboolean | gst_photography_get_exposure ()
gboolean | gst_photography_get_white_balance_mode ()
gboolean | gst_photography_get_colour_tone_mode ()
gboolean | gst_photography_get_scene_mode ()
gboolean | gst_photography_get_flash_mode ()
gboolean | gst_photography_get_noise_reduction ()
gboolean | gst_photography_get_zoom ()
gboolean | gst_photography_set_ev_compensation ()
gboolean | gst_photography_set_iso_speed ()
gboolean | gst_photography_set_aperture ()
gboolean | gst_photography_set_exposure ()
gboolean | gst_photography_set_white_balance_mode ()
gboolean | gst_photography_set_colour_tone_mode ()
gboolean | gst_photography_set_scene_mode ()
gboolean | gst_photography_set_flash_mode ()
gboolean | gst_photography_set_noise_reduction ()
gboolean | gst_photography_set_zoom ()
GstPhotoCaps | gst_photography_get_capabilities ()
gboolean | gst_photography_prepare_for_capture ()
void | gst_photography_set_autofocus ()
gboolean | gst_photography_set_config ()
gboolean | gst_photography_get_config ()

## Properties

guint | aperture | Read / Write
gulong | capabilities | Read
GstColourToneMode | colour-tone-mode | Read / Write
gfloat | ev-compensation | Read / Write
guint | exposure | Read / Write
GstFlashMode | flash-mode | Read / Write
GstFlickerReductionMode | flicker-mode | Read / Write
GstFocusMode | focus-mode | Read / Write
GstCaps * | image-capture-supported-caps | Read
guint | iso-speed | Read / Write
GstSceneMode | scene-mode | Read / Write
GstWhiteBalanceMode | white-balance-mode | Read / Write
GstCaps * | image-preview-supported-caps | Read
GstPhotographyNoiseReduction | noise-reduction | Read / Write
gfloat | zoom | Read / Write

## Types and Values

| GstPhotography
enum | GstPhotographyNoiseReduction
enum | GstWhiteBalanceMode
enum | GstColourToneMode
enum | GstSceneMode
enum | GstFlashMode
enum | GstFlickerReductionMode
enum | GstFocusMode
enum | GstFocusStatus
enum | GstPhotoCaps
enum | GstPhotoShakeRisk

## Object Hierarchy

        GInterface
        ╰── GstPhotography

## Prerequisites

GstPhotography requires GstImplementsInterface and GstElement.

## Description

## Functions

### GstPhotoCapturePrepared ()

    void
    (*GstPhotoCapturePrepared) (gpointer data,
                                const GstCaps *configured_caps);

### gst_photography_get_ev_compensation ()

    gboolean
    gst_photography_get_ev_compensation (GstPhotography *photo,
                                         gfloat *ev_comp);

### gst_photography_get_iso_speed ()

    gboolean
    gst_photography_get_iso_speed (GstPhotography *photo,
                                   guint *iso_speed);

### gst_photography_get_aperture ()

    gboolean
    gst_photography_get_aperture (GstPhotography *photo,
                                  guint *aperture);

### gst_photography_get_exposure ()

    gboolean
    gst_photography_get_exposure (GstPhotography *photo,
                                  guint32 *exposure);

### gst_photography_get_white_balance_mode ()

    gboolean
    gst_photography_get_white_balance_mode
                                   (GstPhotography *photo,
                                    GstWhiteBalanceMode *wb_mode);

### gst_photography_get_colour_tone_mode ()

    gboolean
    gst_photography_get_colour_tone_mode (GstPhotography *photo,
                                          GstColourToneMode *tone_mode);

### gst_photography_get_scene_mode ()

    gboolean
    gst_photography_get_scene_mode (GstPhotography *photo,
                                    GstSceneMode *scene_mode);

### gst_photography_get_flash_mode ()

    gboolean
    gst_photography_get_flash_mode (GstPhotography *photo,
                                    GstFlashMode *flash_mode);

### gst_photography_get_noise_reduction ()

    gboolean
    gst_photography_get_noise_reduction (GstPhotography *photo,
                                         GstPhotographyNoiseReduction *noise_reduction);

### gst_photography_get_zoom ()

    gboolean
    gst_photography_get_zoom (GstPhotography *photo,
                              gfloat *zoom);

### gst_photography_set_ev_compensation ()

    gboolean
    gst_photography_set_ev_compensation (GstPhotography *photo,
                                         gfloat ev_comp);

### gst_photography_set_iso_speed ()

    gboolean
    gst_photography_set_iso_speed (GstPhotography *photo,
                                   guint iso_speed);

### gst_photography_set_aperture ()

    gboolean
    gst_photography_set_aperture (GstPhotography *photo,
                                  guint aperture);

### gst_photography_set_exposure ()

    gboolean
    gst_photography_set_exposure (GstPhotography *photo,
                                  guint exposure);

### gst_photography_set_white_balance_mode ()

    gboolean
    gst_photography_set_white_balance_mode
                                   (GstPhotography *photo,
                                    GstWhiteBalanceMode wb_mode);

### gst_photography_set_colour_tone_mode ()

    gboolean
    gst_photography_set_colour_tone_mode (GstPhotography *photo,
                                          GstColourToneMode tone_mode);

### gst_photography_set_scene_mode ()

    gboolean
    gst_photography_set_scene_mode (GstPhotography *photo,
                                    GstSceneMode scene_mode);

### gst_photography_set_flash_mode ()

    gboolean
    gst_photography_set_flash_mode (GstPhotography *photo,
                                    GstFlashMode flash_mode);

### gst_photography_set_noise_reduction ()

    gboolean
    gst_photography_set_noise_reduction (GstPhotography *photo,
                                         GstPhotographyNoiseReduction noise_reduction);

### gst_photography_set_zoom ()

    gboolean
    gst_photography_set_zoom (GstPhotography *photo,
                              gfloat zoom);

### gst_photography_get_capabilities ()

    GstPhotoCaps
    gst_photography_get_capabilities (GstPhotography *photo);

### gst_photography_prepare_for_capture ()

    gboolean
    gst_photography_prepare_for_capture (GstPhotography *photo,
                                         GstPhotoCapturePrepared func,
                                         GstCaps *capture_caps,
                                         gpointer user_data);

### gst_photography_set_autofocus ()

    void
    gst_photography_set_autofocus (GstPhotography *photo,
                                   gboolean on);

### gst_photography_set_config ()

    gboolean
    gst_photography_set_config (GstPhotography *photo,
                                GstPhotoSettings *config);

### gst_photography_get_config ()

    gboolean
    gst_photography_get_config (GstPhotography *photo,
                                GstPhotoSettings *config);

## Types and Values

### GstPhotography

    typedef struct _GstPhotography GstPhotography;

### enum GstPhotographyNoiseReduction

#### Members

GST_PHOTOGRAPHY_NOISE_REDUCTION_BAYER |  |
GST_PHOTOGRAPHY_NOISE_REDUCTION_YCC |  |
GST_PHOTOGRAPHY_NOISE_REDUCTION_TEMPORAL |  |
GST_PHOTOGRAPHY_NOISE_REDUCTION_FIXED |  |
GST_PHOTOGRAPHY_NOISE_REDUCTION_EXTRA |  |

### enum GstWhiteBalanceMode

#### Members

GST_PHOTOGRAPHY_WB_MODE_AUTO |  |
GST_PHOTOGRAPHY_WB_MODE_DAYLIGHT |  |
GST_PHOTOGRAPHY_WB_MODE_CLOUDY |  |
GST_PHOTOGRAPHY_WB_MODE_SUNSET |  |
GST_PHOTOGRAPHY_WB_MODE_TUNGSTEN |  |
GST_PHOTOGRAPHY_WB_MODE_FLUORESCENT |  |

### enum GstColourToneMode

#### Members

GST_PHOTOGRAPHY_COLOUR_TONE_MODE_NORMAL |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_SEPIA |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_NEGATIVE |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_GRAYSCALE |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_NATURAL |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_VIVID |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_COLORSWAP |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_SOLARIZE |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_OUT_OF_FOCUS |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_SKY_BLUE |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_GRASS_GREEN |  |
GST_PHOTOGRAPHY_COLOUR_TONE_MODE_SKIN_WHITEN |  |

### enum GstSceneMode

#### Members

GST_PHOTOGRAPHY_SCENE_MODE_MANUAL |  |
GST_PHOTOGRAPHY_SCENE_MODE_CLOSEUP |  |
GST_PHOTOGRAPHY_SCENE_MODE_PORTRAIT |  |
GST_PHOTOGRAPHY_SCENE_MODE_LANDSCAPE |  |
GST_PHOTOGRAPHY_SCENE_MODE_SPORT |  |
GST_PHOTOGRAPHY_SCENE_MODE_NIGHT |  |
GST_PHOTOGRAPHY_SCENE_MODE_AUTO |  |

### enum GstFlashMode

#### Members

GST_PHOTOGRAPHY_FLASH_MODE_AUTO |  |
GST_PHOTOGRAPHY_FLASH_MODE_OFF |  |
GST_PHOTOGRAPHY_FLASH_MODE_ON |  |
GST_PHOTOGRAPHY_FLASH_MODE_FILL_IN |  |
GST_PHOTOGRAPHY_FLASH_MODE_RED_EYE |  |

### enum GstFlickerReductionMode

#### Members

GST_PHOTOGRAPHY_FLICKER_REDUCTION_OFF |  |
GST_PHOTOGRAPHY_FLICKER_REDUCTION_50HZ |  |
GST_PHOTOGRAPHY_FLICKER_REDUCTION_60HZ |  |
GST_PHOTOGRAPHY_FLICKER_REDUCTION_AUTO |  |

### enum GstFocusMode

#### Members

GST_PHOTOGRAPHY_FOCUS_MODE_AUTO |  |
GST_PHOTOGRAPHY_FOCUS_MODE_MACRO |  |
GST_PHOTOGRAPHY_FOCUS_MODE_PORTRAIT |  |
GST_PHOTOGRAPHY_FOCUS_MODE_INFINITY |  |
GST_PHOTOGRAPHY_FOCUS_MODE_HYPERFOCAL |  |
GST_PHOTOGRAPHY_FOCUS_MODE_EXTENDED |  |
GST_PHOTOGRAPHY_FOCUS_MODE_CONTINUOUS_NORMAL |  |
GST_PHOTOGRAPHY_FOCUS_MODE_CONTINUOUS_EXTENDED |  |

### enum GstFocusStatus

#### Members

GST_PHOTOGRAPHY_FOCUS_STATUS_NONE |  |
GST_PHOTOGRAPHY_FOCUS_STATUS_RUNNING |  |
GST_PHOTOGRAPHY_FOCUS_STATUS_FAIL |  |
GST_PHOTOGRAPHY_FOCUS_STATUS_SUCCESS |  |

### enum GstPhotoCaps

#### Members

GST_PHOTOGRAPHY_CAPS_NONE |  |
GST_PHOTOGRAPHY_CAPS_EV_COMP |  |
GST_PHOTOGRAPHY_CAPS_ISO_SPEED |  |
GST_PHOTOGRAPHY_CAPS_WB_MODE |  |
GST_PHOTOGRAPHY_CAPS_TONE |  |
GST_PHOTOGRAPHY_CAPS_SCENE |  |
GST_PHOTOGRAPHY_CAPS_FLASH |  |
GST_PHOTOGRAPHY_CAPS_ZOOM |  |
GST_PHOTOGRAPHY_CAPS_FOCUS |  |
GST_PHOTOGRAPHY_CAPS_APERTURE |  |
GST_PHOTOGRAPHY_CAPS_EXPOSURE |  |
GST_PHOTOGRAPHY_CAPS_SHAKE |  |
GST_PHOTOGRAPHY_CAPS_NOISE_REDUCTION |  |
GST_PHOTOGRAPHY_CAPS_FLICKER_REDUCTION |  |
GST_PHOTOGRAPHY_CAPS_ALL |  |

### enum GstPhotoShakeRisk

#### Members

GST_PHOTOGRAPHY_SHAKE_RISK_LOW |  |
GST_PHOTOGRAPHY_SHAKE_RISK_MEDIUM |  |
GST_PHOTOGRAPHY_SHAKE_RISK_HIGH |  |

## Property Details

### The `“aperture”` property

      “aperture”                 guint

Aperture defines the size of lens opening (0 = auto).

Flags: Read / Write

Allowed values: <= 255

Default value: 0

### The `“capabilities”` property

      “capabilities”             gulong

Tells the photo capabilities of the device.

Flags: Read

### The `“colour-tone-mode”` property

      “colour-tone-mode”         GstColourToneMode

Colour tone setting changes colour shading in the photo.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_COLOUR_TONE_MODE_NORMAL

### The `“ev-compensation”` property

      “ev-compensation”          gfloat

EV compensation affects the brightness of the image.

Flags: Read / Write

Allowed values: [-2.5,2.5]

Default value: 0

### The `“exposure”` property

      “exposure”                 guint

Exposure time defines how long the shutter will stay open (0 = auto).

Flags: Read / Write

Default value: 0

### The `“flash-mode”` property

      “flash-mode”               GstFlashMode

Flash mode defines how the flash light should be used.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_FLASH_MODE_AUTO

### The `“flicker-mode”` property

      “flicker-mode”             GstFlickerReductionMode

Flicker reduction mode defines a line frequency for flickering prevention.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_FLICKER_REDUCTION_OFF

### The `“focus-mode”` property

      “focus-mode”               GstFocusMode

Focus mode defines the range of focal lengths to use in autofocus search.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_FOCUS_MODE_AUTO

### The `“image-capture-supported-caps”` property

      “image-capture-supported-caps” GstCaps *

Caps describing supported image capture formats.

Flags: Read

### The `“iso-speed”` property

      “iso-speed”                guint

ISO speed defines the light sensitivity (0 = auto).

Flags: Read / Write

Allowed values: <= 6400

Default value: 0

### The `“scene-mode”` property

      “scene-mode”               GstSceneMode

Scene mode works as a preset for different photo shooting mode settings.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_SCENE_MODE_AUTO

### The `“white-balance-mode”` property

      “white-balance-mode”       GstWhiteBalanceMode

White balance affects the color temperature of the photo.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_WB_MODE_AUTO

### The `“image-preview-supported-caps”` property

      “image-preview-supported-caps” GstCaps *

Caps describing supported image preview formats.

Flags: Read

### The `“noise-reduction”` property

      “noise-reduction”          GstPhotographyNoiseReduction

Which noise reduction modes are enabled (0 = disabled).

Flags: Read / Write

### The `“zoom”` property

      “zoom”                     gfloat

How much the resulted image will be zoomed.

Flags: Read / Write

Allowed values: [1,10]

Default value: 1